typedef struct lista
{
    char nome[50];
    lista *prox;
} Lista;

     Lista *lista;

Lista *crialista()
{
    return NULL;
}

int listavazia (Lista *l)
{
    return l == NULL;
}

Lista *adiciona(Lista *l, char nome[50])
{
    Lista *aux=l, *novo = (Lista*)malloc(sizeof(Lista));
    strcpy(novo->nome,nome);
    if (aux==NULL)
    {
        novo->prox = novo;
        return novo;
    }
    else
    {
        do
        {
            aux=aux->prox;
        } while (aux->prox!=l);
        aux->prox = novo;
        novo->prox = lista;

        return l;
    }
}

Lista *inserelista (Lista *l, char nome[50])
{
    Lista *novo = (Lista*)malloc(sizeof(Lista)), *aux;
    strcpy(novo->nome,nome);
    novo->prox=l;
    if (l==NULL)
        novo->prox = novo;
    else
    {
        aux = l;
        do
        {
            aux=aux->prox;
        } while (aux->prox!=l);
        aux->prox = novo;
    }
    return novo;
}

Lista *remover(Lista *p)
{
    Lista *ant, *l=p;
    if (p)
    {
        if(p->prox!=l)
        {
            while (p->prox!=l)
            {
                ant=p;
                p=p->prox;
            }
            ant->prox=l;
            free(p);
            return l;
        }
        else
        {
            free(p);
            return NULL;
        }
    }
}

void imprimelista (Lista *l)
{
    Lista *p=l;
    if (p) do
    {
        printf("\n\n\nNome: %s\n", p->nome);
        p=p->prox;
    } while (p!=l);
}

Lista *busca (Lista *l, char nome[50])
{
    Lista *p=l;
    if (p) do
    {
        if (strcmp(nome, p->nome)==0)
        {
            printf("Elemento Encontrado!\n");
            return p;
        }
        p = p->prox;
    } while (p!=l);
    printf("Elemento Nao Encontrado!\n");
    return NULL;
}


Lista *retiraespecifico(Lista *l, char nome[50])
{
    Lista *ant, *p=l, *ult;
    if (p)
    {
        if (p->prox==l)
        {
            if (strcmp(nome, p->nome)==0)
            {
                free(p);
                return NULL;
            }
            printf("Elemento Nao Encontrado!");
        }
        else
        {
             while (p->prox!=l && strcmp(nome, p->nome)!=0)
            {
                ant=p;
                p=p->prox;
            }

            if (strcmp(nome,p->nome)!=0)
                printf("Elemento Nao Encontrado!");

            else if (strcmp(nome,p->nome)==0 && p==l)
            {
                for (ult=l; ult->prox!=l; ult=ult->prox);
                l = p->prox;
                ult->prox=l;
            }


            else if (strcmp(nome,p->nome)==0)
                ant->prox = p->prox;
            free(p);
            return l;
        }
    }
    return l;
}

void destroilista(Lista *l)
{
    Lista *p=l, *t;
    if (p) do
    {
        t = p->prox;
        free(p);
        p = t;
    } while (p!=l);
}

Lista *adicionaespecifico(Lista *l, char nome[50])
{
    Lista *novo, *ant = NULL, *p=l;

    if (p) do
    {
        ant = p;
        p = p->prox;
    } while (p!=l && strcmp(nome,p->nome)>0);

    novo = (Lista*)malloc(sizeof(Lista));
    strcpy(novo->nome,nome);

    if (ant==NULL)
    {
        novo->prox = novo;
        return novo;
    }

    else
    {
        novo->prox = ant->prox;
        ant->prox = novo;
    }
    return l;
}

void sorteio(Lista *l)
{
    Lista *p=l;
    int i, num;
    num = rand()%800+201;
    for (i=0; i<=num; i++)
        p=p->prox;
    printf("Numero Sorteado : %d\nSoldado : %s",num,p->nome);
}

 void menu()
 {
     int opcao;
     char nome[50];
     do
     {
         printf("\n\nMenu\n1 - Criar Lista\n2 - Destroi Lista\n3 - Lista Vazia\n4 - Adicionar\n5 - Adicionar no Inicio\n6 - Adicionar Ordenado\n7 - Remover do Final\n8 - Retirar Especifico\n9 - Buscar Elemento\n10 - Mostrar Lista\n11 - Sorteio\n12 - Sair\nOpcao: ");
         scanf("%d",&opcao);

         switch (opcao)
         {
             case 1: lista = crialista(); break;
             case 2: destroilista(lista); break;
             case 3: if(listavazia(lista))
                            printf("Lista Vazia!\n");
                          else
                            printf("Nao!\n"); break;
             case 4: printf("Nome: ");
                          scanf("%s", &nome);
                          lista = adiciona(lista, nome); break;
             case 5: printf("Nome: ");
                          scanf("%s", &nome);
                          lista = inserelista(lista, nome); break;
            case 6: printf("Nome: ");
                          scanf("%s", &nome);
                          lista = adicionaespecifico(lista, nome); break;
            case 7: lista= remover(lista); break;
            case 8: printf("Nome: ");
                        scanf("%s",&nome);
                        lista = retiraespecifico(lista, nome); break;
            case 9: printf("Nome: ");
                        scanf("%s", &nome);
                        busca(lista, nome); break;
            case 10: imprimelista(lista);break;
            case 11: sorteio(lista); break;
            case 12: break;
            default: printf("Opcao Inexistente!\n");
         }
     } while (opcao!=12);
 }
